From 2fc07c11a831beceaac1e0ab7d36cfffcf94ddfd Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Feb 23 2020 09:06:28 +0000
Subject: [PATCH 48/2232] Merge pull request #40 from dtolnay/box


Protect from ADL in Box construction and assignment
---

diff --git a/include/cxxbridge.h b/include/cxxbridge.h
index a0d9dbb..0bfe805 100644
--- a/include/cxxbridge.h
+++ b/include/cxxbridge.h
@@ -66,7 +66,7 @@ public:
   RustBox(RustBox &&other) noexcept : repr(other.repr) { other.repr = 0; }
   RustBox(const T &val) {
     this->uninit();
-    new (this->deref_mut()) T(val);
+    ::new (this->deref_mut()) T(val);
   }
   RustBox &operator=(const RustBox &other) {
     if (this != &other) {
@@ -74,7 +74,7 @@ public:
         **this = *other;
       } else {
         this->uninit();
-        new (this->deref_mut()) T(*other);
+        ::new (this->deref_mut()) T(*other);
       }
     }
     return *this;

